# Esercizio PL 82 Cloud computing capacity

# DATI
set Contratti;
param c_year {Contratti};	# [$/anno]
param c_hour {Contratti};	# [$/ora]
param q;					# Domanda per analisi parametrica

# VARIABILI
var utilizzo;				# [ore/anno]
var costomin;				# [$/anno]

# VINCOLI
# Vincolo per l'analisi parametrica [ore/anno]
s.t. Parametrica: 
  utilizzo = q;

# OBIETTIVO
# F.o. maxmin per determinare il costo minimo tra i contratti [$/anno]
maximize z: costomin;
s.t. MaxMin {i in Contratti}:
  costomin <= c_year[i] + c_hour[i] * utilizzo;

########################
data;

param q := 5479;

set Contratti:= Heavy Medium Light OnDemand;

param:   c_year   c_hour :=
Heavy     1560    0.128
Medium    1280    0.192
Light      552    0.312
OnDemand     0    0.640;

end;

# Analisi parametrica
# On-demand fino a q=1682.92683  z=1077.07317
# Light     fino a q=5478.26087  z=2261.21739
# Heavy     per valori di q superiori

